//---------------------------------------------------------
// ColorSplash by Andreas Gustafsson (Shadow/Noice) (C)2000
//---------------------------------------------------------
#include "stdafx.h"
#include "Texture.h"

//----------------------------------------
// Usefull debugger thingy.
void DebugOut(const char *szFormat, ...);
//----------------------------------------

// Change your App Name.
char szAppName[] = "ColorSplash by Andreas Gustafsson (Shadow/Noice) (C) 2000";

// Timer info.  Very useful for keeping animated stuff in sync on different computers.
extern float fTime, fDeltaTime;

// Current window dimensions.
extern GLsizei g_w, g_h;
CTexture gTexExample;
CTexture gTexExample2;

GLUquadricObj *quadObj;

float v1,v2,v3,v4;
double rv1=0;

float rcol[16],gcol[16],bcol[16];

// Startup Stuff.
bool Init()	// Called right after the window is created, and OpenGL is initialized.
{
	int h;

	glClearColor(0.0,0.0,0.0,0.0);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glEnable(GL_BLEND);
	for(h=0;h<16;h++)
	{
		rcol[h]=(float)(0.1+0.1*sin(h*PI/8));
		gcol[h]=(float)(0.1+0.1*sin((h+4)*PI/8));
		bcol[h]=(float)(0.1+0.1*sin((h+8)*PI/8));
	}
   glViewport (0, 0, (GLsizei) g_w, (GLsizei) g_h); 
   glMatrixMode (GL_PROJECTION);
   glLoadIdentity ();
   gluPerspective(65.0, (GLfloat) g_w/(GLfloat) g_h, 1.0, 20.0);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   glTranslatef (0.0, 0.0, -3.0);

   gTexExample.LoadJPG( "test2.jpg" );
   gTexExample2.LoadJPG( "bak2.jpg" );

	quadObj=gluNewQuadric();
	gluQuadricTexture(quadObj,true); 
	
	return true;
}

void Shutdown() // Called right after the window is destroyed.
{
}

void drawSphere()
{
	gTexExample2.Use(); 
	glColor3f(0.6f,0.6f,0.6f);
	gluSphere(quadObj,3.5f,16,16);
}


void drawTri(float xs, float ys, float rot,float xp, float yp,float r,float g,float b)
{
	glPushMatrix();
	glTranslatef(xp,yp,0);
	glRotatef (rot, 0.0, 0.0, 1.0); /* Rotation a degrees around axis X  */
	glScalef(xs,ys,1);
	glColor3f(r,g,b);
	glBegin(GL_QUADS);
	glTexCoord2f( 0, 0 );
	glVertex3f(-1,-1,0);
	glTexCoord2f( 1, 0 );
	glVertex3f(1,-1,0);
	glTexCoord2f( 1, 1 );
	glVertex3f(1,1,0);
	glTexCoord2f( 0, 1 );
	glVertex3f(-1,1,0);
	glEnd();
	glPopMatrix ();
}

// Draw all the scene related stuff.
void Render()
{
	int x;
	float xs,ys,rot,xp,yp;

	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	
	glDisable(GL_BLEND);
	glPushMatrix();
	glRotatef((float)rv1, 0, 0, 1.f );
	gTexExample2.Use(); // Tells OpenGL to use this texture.
	drawSphere();
	glPopMatrix();
	glEnable(GL_BLEND);	
	gTexExample.Use(); // Tells OpenGL to use this texture.
	glEnable( GL_TEXTURE_2D );
	for(x=0;x<16;x++)
	{
		xs=(float)(0.8+0.5*cos((v4+x*17)*PI/128));
		ys=(float)(0.8+0.5*sin((v3+x*10)*PI/256));
		rot=(float)(180+180*sin((v4-x*12)*PI/512));
		xp=(float)(0.3*sin((v1+x*3)*PI/128));
		yp=(float)(0.2*cos((v2+x*9)*PI/128));
   		drawTri(xs,ys,rot,xp,yp,rcol[x],gcol[x],bcol[x]);
   }
	v1+=fDeltaTime*50;
	if(v1>1024) v1-=1024;		
	v2+=fDeltaTime*20;
	if(v2>1024) v2-=1024;		
	v3+=fDeltaTime*-60;
	if(v3>1024) v3-=1024;		
	v4+=100*fDeltaTime;
	if(v4>1024) v4-=1024;		

	rv1+=10.0f*fDeltaTime;
	if(rv1>360) rv1-=360;

}
